hdu 1069 线性dp LIS变形题

Monkey and Banana
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 23070 Accepted Submission(s): 12365

Problem Description A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.

Sample Input1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
Sample OutputCase 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342
Source University of Ulm Local Contest 1996

看到题目想到的是LIS的经典变形俄罗斯套娃,想用算法复杂度O(nlogn)的做法去做;可是在写的时候发现 每个长方形的高度并不相同,不能用单纯求一个LIS就完事了,还是要用O(n方)的做法去做,
dp[i]表示以第i个木块做最下面的木块时,高度为多高;
状态转移方程为 dp[i]=max(dp[i],dp[j]+leve[j].z); leve[j].x<i.x&&j.y<i.y
leve[maxn]存储每个木块的信息;
以下是ac代码,用了15ms,不过去榜单上看了一下,有蛮多人花了0ms就过了,暂时不知道他们是怎么做到的,以后知道了再来复更吧;


#include <stdio.h>
#include <algorithm>

using namespace std;
const int maxn=33;
struct leve{
    int x,y,z;
}q[maxn*6];
int dp[maxn*6];
bool cmp(leve a,leve b){
    return a.x==b.x?(a.y==b.y?(a.z>b.z):a.y>b.y):a.x<b.x;
}
int main()
{
    int cas=1,n,a,b,c;
    while(scanf("%d",&n)&&n){
        int tot=0;
        for(int i=0;i<n;i++){
            scanf("%d%d%d",&a,&b,&c);
            q[tot++]={a,b,c};q[tot++]={c,b,a};
            q[tot++]={b,c,a};q[tot++]={a,c,b};
            q[tot++]={c,a,b};q[tot++]={b,a,c};
        }
        sort(q,q+6*n,cmp);
        int res=0;
        for(int i=0;i<6*n;i++){
            dp[i]=q[i].z;
            for(int j=0;j<i;j++){
                if(q[j].x<q[i].x&&q[j].y<q[i].y){
                    dp[i]=max(dp[i],dp[j]+q[i].z);
                }
            }
            res=max(res,dp[i]);
            }
        printf("Case %d: maximum height = %d\n",cas++,res);
    }
    return 0;
   }
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值